package server

import (
	"net"

	"git.loafle.net/commons/server-go"
	cswf "git.loafle.net/commons/server-go/web/fasthttp"
	ogeg "git.loafle.net/overflow/gateway/external/grpc"
)

type ServerHandler interface {
	cswf.ServerHandler
}

type ServerHandlers struct {
	cswf.ServerHandlers
}

func (sh *ServerHandlers) Init(serverCtx server.ServerCtx) error {
	if err := sh.ServerHandlers.Init(serverCtx); nil != err {
		return nil
	}
	ogeg.InitPackage()

	return nil
}

func (sh *ServerHandlers) Listener(serverCtx server.ServerCtx) (net.Listener, error) {
	l, err := net.Listen("tcp", "192.168.1.101:44449")
	if nil != err {
		return nil, err
	}

	return l, nil
}

func (sh *ServerHandlers) Destroy(serverCtx server.ServerCtx) {
	ogeg.DestroyPackage()

	sh.ServerHandlers.Destroy(serverCtx)
}
